#pragma once
#include "DxLib.h"

#define CELL_WIDTH	40					//^C̕
#define CELL_HEIGHT 40					//^C̍
#define CELL_NUM_X	144					//^C̉̐
#define CELL_NUM_Y	27					//^C̏c̐
#define WINDOW_X	1920				//EBhE̕
#define WINDOW_Y	1080				//EBhE̍

int chipgraphicHandle[16];				//^CG̑|Zŏo
int tileImgX;							//wi摜XW
int characterPack;						//i[ϐ
int rawNum = 0;							//̃^Cio[
int columnNum = 0;						//c̃^Cio[
int num;								//^C̔ԍ
int i;									//forJE^[
int j;									//forJE^[
char buffer[10];						//ϐ
bool eofFlag = false;					//eofiend of filejotO

struct Cell								//^Cp̍\̂
{
	int graphicHandle = 0;				//摜p̕ϐ
	Cell() {};
};

class Map																									//mapNX
{
public:

	Cell cell[CELL_NUM_X][CELL_NUM_Y];																		//\̂Ƀ^C̉ci[

	Map()
	{
		LoadDivGraph("img/tiled.png", 16, 16, 1, 40, 40, chipgraphicHandle);	//^C摜ǂݍ
		FILE* filePointer;																					//t@C̃|C^錾
		fopen_s(&filePointer, "map.csv", "r");																//fopen_s֐map.csvǂݎ`ŊJ
		if (filePointer == NULL)																			//filePointeȑꍇ
		{
			DebugBreak();																					//fobO~
		}

		memset(buffer, 0, sizeof(buffer));						//memset֐ŃbufferZbgAsizeofZqŗvf߂

		while (1)
		{
			while (1)
			{
				characterPack = fgetc(filePointer);										//fgetc֐filepointer當ǂcharacterPackɊi[
				if (characterPack == EOF)
				{
					eofFlag = true;														//EndOfFileo
					break;																//[v𔲂
				}
				if (characterPack != ',' && characterPack != '\n')						//؂肩słȂ
				{
					strcat_s(buffer, (const char*)&characterPack);						//strcat_s֐bufferɘAAconst char֐ŏ
				}
				else
				{
					num = atoi(buffer);													//atoi֐bufferint^ɒāA[Jϐnumɑ
					cell[columnNum][rawNum].graphicHandle = chipgraphicHandle[num];		//numԖڂ̃`bv摜̃nh擾
					memset(buffer, 0, sizeof(buffer));									//bufferZbg
					break;																//؂肩sȂ̂Ń[v𔲂
				}
			}
			if (eofFlag)																//1}bvɂȂ
			{
				break;																	//[v𔲂
			}
			if (characterPack == ',')													//؂o
			{
				columnNum++;															//̐𑝂₷
			}
			if (characterPack == '\n')													//s
			{
				rawNum++;																//s𑝂₷
				columnNum = 0;															//0ɂ
			}
		}
		fclose(filePointer);															//t@C
	}

	void View()
	{
		for (i = 0; i < CELL_NUM_X; i++)
		{
			for (j = 0; j < CELL_NUM_Y; j++)
			{
				DrawExtendGraph(i * CELL_WIDTH + tileImgX, j * CELL_HEIGHT, (i + 1) * CELL_WIDTH + tileImgX, (j + 1) * CELL_HEIGHT, cell[i][j].graphicHandle, TRUE);
			}
		}
	}

	void All()
	{
		View();
	}

};