#pragma once
#include "DxLib.h"
#include "function.h"

#define COLLISION_CELL_WIDTH	40			//蔻BOX̕
#define COLLISION_CELL_HEIGHT	40			//蔻BOX̍
#define COLLISION_CELL_NUM_X	144			//蔻BOX̉̐
#define COLLISION_CELL_NUM_Y	27			//蔻BOX̏c̐
#define COLLISION_WINDOW_X		1920		//EBhE̕
#define COLLISION_WINDOW_Y		1080		//EBhE̍

int collisionBoxHandle[2];					//蔻BOXG̑|Zŏo
int collisionBoxX;							//wi蔻BOXXW
int collisionMarker;						//i[ϐ
int collisionRawNum = 0;					//̓蔻BOXio[
int collisionColumnNum = 0;					//c̓蔻BOXio[
int collisionNum;							//蔻BOX̔ԍ
int ci;										//forJE^[
int cj;										//forJE^[
char collisionBuffer[10];					//ϐ
bool collisionEofFlag = false;				//eofiend of filejotO

struct collisionCell						//蔻BOXp̍\̂
{
	int collisionBoxHandle{};					//蔻Ǘp̕ϐ
	collisionCell() {};
};

class Collision								//wi蔻NX
{
public:

	collisionCell collisionCell[COLLISION_CELL_NUM_X][COLLISION_CELL_NUM_Y];	//\̂ɓ蔻BOX̉ci[

	Collision()
	{
		LoadDivGraph("img/hit.png", 2, 2, 1, 40, 40, collisionBoxHandle);		//蔻`FbNp摜
		FILE* collisionFilePointer;												//t@C̃|C^錾
		fopen_s(&collisionFilePointer, "collision.csv", "r");					//fopen_s֐collision.csvǂݎ`ŊJ
		if (collisionFilePointer == NULL)										//collisionFilePointeȑꍇ
		{
			DebugBreak();														//fobO~
		}


		memset(collisionBuffer, 0, sizeof(collisionBuffer));					//memset֐ŃbufferZbgAsizeofZqŗvf߂

		while (1)
		{
			while (1)
			{
				collisionMarker = fgetc(collisionFilePointer);					//fgetc֐filepointer當ǂcharacterPackɊi[
				if (collisionMarker == EOF)
				{
					collisionEofFlag = true;									//EndOfFileo
					break;														//[v𔲂
				}
				if (collisionMarker != ',' && collisionMarker != '\n')			//؂肩słȂ
				{
					strcat_s(collisionBuffer, (const char*)&collisionMarker);	//strcat_s֐bufferɘAAconst char֐ŏ
				}
				else
				{
					collisionNum = atoi(collisionBuffer);						//atoi֐bufferint^ɒāA[Jϐnumɑ
					collisionCell[collisionColumnNum][collisionRawNum].collisionBoxHandle = collisionBoxHandle[collisionNum];		//numԖڂ̃`bv摜̃nh擾
					memset(collisionBuffer, 0, sizeof(collisionBuffer));		//bufferZbg
					break;														//؂肩sȂ̂Ń[v𔲂
				}
			}
			if (collisionEofFlag)												//1}bvɂȂ
			{
				break;															//[v𔲂
			}
			if (collisionMarker == ',')											//؂o
			{
				collisionColumnNum++;											//̐𑝂₷
			}
			if (collisionMarker == '\n')										//s
			{
				collisionRawNum++;												//s𑝂₷
				collisionColumnNum = 0;											//0ɂ
			}
		}
		fclose(collisionFilePointer);											//t@C
	}

	void ColBox()
	{
		const int playerW = 30;
		const int playerH = 50;

		int playerLX = playerX - playerW - tileImgX;
		int playerLY = playerY - playerH;
		int playerRX = playerX + playerW - tileImgX;
		int playerRY = playerY + playerH;
		int playerVX = playerX - playerXPrev;
		int playerVY = playerY - playerYPrev;

		int idleLX = playerLX / COLLISION_CELL_WIDTH;	//vC[X
		int idleLY = playerLY / COLLISION_CELL_HEIGHT;	//vC[Y
		int idleRX = playerRX / COLLISION_CELL_WIDTH;	//vC[EX
		int idleRY = playerRY / COLLISION_CELL_HEIGHT;	//vC[EY

		int blockLX;
		int blockLY;
		int blockRX;
		int blockRY;

		//ubN̉ɓ
		if (idleLY < 0 || idleRY < 0)
		{
			return;
		}

		for (int iy = idleLY; iy < idleRY + 1; iy++)
		{
			for (int ix = idleLX; ix < idleRX + 1; ix++)
			{
				if (collisionCell[ix][iy].collisionBoxHandle == collisionBoxHandle[1])
				{
					//ubN̍W
					blockLX = ix * COLLISION_CELL_WIDTH;
					blockLY = iy * COLLISION_CELL_HEIGHT;
					blockRX = blockLX + COLLISION_CELL_WIDTH;
					blockRY = blockLY + COLLISION_CELL_HEIGHT;

					//{ɓĂ邩H
					if (playerLX <= blockRX && blockLX <= playerRX &&
						playerLY <= blockRY && blockLY <= playerRY)
					{
						// Փ˂̂ł߂荞݂߂iANVj
						//ubN̏[
						if ((playerRY - blockLY > 0) &&
							(playerRY - blockLY <= 16) &&
							(collisionCell[ix][iy - 1].collisionBoxHandle == collisionBoxHandle[0]) &&
							(playerVY > 0))
						{
							playerY = blockLY - playerH;
							playerYPrev = playerY;
							jumpFlag = false;
						}
					}
				}
			}
		}

		// 𒲂ׂ
		idleRY = (playerY + playerH) / COLLISION_CELL_HEIGHT;
		//WvłȂ̂ɁAƂ󒆂ɂȂH
		if (!jumpFlag &&
			(collisionCell[idleLX][idleRY].collisionBoxHandle == collisionBoxHandle[0])&&
			(collisionCell[idleRX][idleRY].collisionBoxHandle == collisionBoxHandle[0]))
		{
			jumpFlag = true;
		}

	}
	void ColAll()
	{
		ColBox();
	}

};